Version:       1.1.0
%global forgeurl https://gitlab.com/libblkio/libblkio
%global tag    v%{version}
%forgemeta

Summary:       Block device I/O library
Name:          libblkio
Release:       3%{?dist}
URL:           %{forgeurl}
Source0:       %{forgesource}
License:       ASL 2.0 or MIT

Patch:         0001-Use-io-uring-0.5.8.patch

# Bundled missing dependencies.
#
# These were created by running "cargo vendor" in the source tree
# and then making a tarball of just the following directories:
# vendor/memfd
# vendor/winapi*
Source1:       vendor.tar.gz

# Bundled dependencies
Provides:      bundled(crate(memfd/default)) = 0.4.1

# Basic build requirements.
BuildRequires: gcc, gcc-c++
BuildRequires: make
BuildRequires: meson
BuildRequires: rust-packaging >= 21
BuildRequires: rustfmt
BuildRequires: cargo
BuildRequires: python3-docutils
BuildRequires: pkgconf
BuildRequires: crate(autocfg/default)
BuildRequires: crate(bitflags/default)
BuildRequires: crate(cc/default)
BuildRequires: crate(cfg-if/default)
BuildRequires: crate(concat-idents/default)
BuildRequires: crate(const-cstr/default)
BuildRequires: crate(io-uring/default)
BuildRequires: crate(lazy_static/default)
BuildRequires: crate(libc/default)
# BuildRequires: crate(memfd...)
BuildRequires: crate(memmap/default)
BuildRequires: crate(memoffset/default)
BuildRequires: crate(nix/default)
BuildRequires: crate(num-traits/default)
BuildRequires: crate(pci-driver/default)
BuildRequires: crate(proc-macro2/default)
BuildRequires: crate(quote/default)
BuildRequires: crate(syn/default)
BuildRequires: crate(unicode-xid/default)
BuildRequires: crate(virtio-bindings/default)


%description
libblkio is a library for high-performance block device I/O with
support for multi-queue devices. A C API is provided so that
applications can use the library from most programming languages.


%package devel
Summary:       Development tools for %{name}
Requires:      %{name}%{_isa} = %{version}-%{release}


%description devel
This package contains development tools for %{name}.


%prep
%forgeautosetup -p1
tar zxf %{SOURCE1}

cat >> Cargo.toml <<EOF
[patch.crates-io]
memfd = { path = 'vendor/memfd' }
winapi = { path = 'vendor/winapi' }
winapi-i686-pc-windows-gnu = { path = 'vendor/winapi-i686-pc-windows-gnu' }
winapi-x86_64-pc-windows-gnu = { path = 'vendor/winapi-x86_64-pc-windows-gnu' }
EOF
%cargo_prep
sed -e 's/--locked/--offline/' -i src/cargo-build.sh

%build
%{meson}
%{meson_build}


%install
%{meson_install}


%files
%license LICENSE-APACHE LICENSE-MIT LICENSE.crosvm
%doc README.rst
%{_libdir}/libblkio.so.1*


%files devel
%license LICENSE-APACHE LICENSE-MIT LICENSE.crosvm
%doc README.rst
%{_includedir}/blkio.h
%{_libdir}/libblkio.so
%{_libdir}/pkgconfig/blkio.pc
%{_mandir}/man3/blkio.3*


%changelog
* Mon Oct 31 2022 Richard W.M. Jones <rjones@redhat.com> - 1.1.0-3
- Initial package
